
;; program dialog interface for Best Fit

(defun label( / I_CARD  WHAT_NOW )
(if (not al_index) (setq al_index 0))
(setq al_list nil al_list '())
(setq file (open "list.txt" "r"))
(setq line (read-line file))
(while line
     (setq al_list (append al_list (list line)))
     (setq line (read-line file))
) ;; while
(close file)

(command "erase" "all" "")
(command "zoom" "all")

(setq I_CARD (load_dialog "label.dcl"))
(if (not (new_dialog "label" I_CARD)) (exit))

(start_image "label_slide")
(setq max_x (dimx_tile "label_slide"))
(setq max_y (dimy_tile "label_slide"))
(slide_image 0 0 max_x max_y "label")
(end_image)

(start_list "al_list")
(mapcar 'add_list al_list)
(end_list)
(action_tile "al_list" "(setq al_index (atoi $value))")

(if (not kb_list) (setq kb_list 1))
(if (not LS) (setq LS 550))
(if (not WS) (setq WS 350))
(if (not ls_inch) (setq ls_inch (/ ls 25.4)))
(if (not ws_inch) (setq ws_inch (/ ws 25.4)))
(if (not LL) (setq LL 55))
(if (not WL) (setq WL 34))

(if (not LEFT) (setq LEFT 10))
(if (not RIGHT) (setq RIGHT 10))
(if (not TOP) (setq TOP 10))
(if (not BOTTOM) (setq BOTTOM 10))

(if (not title) (setq title "Officer's Choice 350 ml."))

(if (not mm_in_ps) (setq mm_in_ps 1))
(if (not mm_in_ls) (setq mm_in_ls 1))
(if (not mm_in_sm) (setq mm_in_sm 1))
(if (not kb_list) (setq kb_list 1))

(if (not ls_ed) (setq ls_ed 550))
(if (not ws_ed) (setq ws_ed 350))

(if (not ll_ed) (setq ll_ed 55))
(if (not wl_ed) (setq wl_ed 34))
(if (not left_ed) (setq left_ed 10))
(if (not right_ed) (setq right_ed 10))
(if (not top_ed) (setq top_ed 10))
(if (not bottom_ed) (setq bottom_ed 10))

(if (= mm_in_ps 1) (set_tile "mmps" "1"))
(if (= mm_in_ps 0) (set_tile "inps" "1"))

(if (= mm_in_ls 1) (set_tile "mmls" "1"))
(if (= mm_in_ls 0) (set_tile "inls" "1"))

(if (= mm_in_sm 1) (set_tile "mmsm" "1"))
(if (= mm_in_sm 0) (set_tile "insm" "1"))

(set_tile "LS" (if (= mm_in_ps 1)
                   (rtos LS 2 2)
                   (rtos ls_inch 2 2)
               )
)
(set_tile "WS" (if (= mm_in_ps 1)
                   (rtos ws 2 2)
                   (rtos ws_inch 2 2)
               )  
)
(set_tile "LL" (rtos LL 2 2))
(set_tile "WL"  (rtos WL 2 2))

(set_tile "LEFT" (rtos LEFT 2 2))
(set_tile "RIGHT"  (rtos RIGHT 2 2))
(set_tile "TOP" (rtos TOP 2 2))
(set_tile "BOTTOM"  (rtos BOTTOM 2 2))
(setq cpr "Developed by Tushar Suradkar. CadGuruCool@Yahoo.com")
(set_tile "title" title)
(set_tile "copyrite" cpr)
(action_tile "LS"
"(setq ls_ed (distof $value 4) ls_inch (distof $value 4))")

(action_tile "WS"
"(setq ws_ed (distof $value 4) ws_inch (distof $value 4))")

(action_tile "LL"
"(setq ll_ed (distof $value 4))")

(action_tile "WL"
"(setq wl_ed (distof $value 4))")

(action_tile "LEFT"
"(setq left_ed (distof $value 4))")

(action_tile "RIGHT"
"(setq right_ed (distof $value 4))")

(action_tile "TOP"
"(setq top_ed (distof $value 4))")

(action_tile "BOTTOM"
"(setq bottom_ed (distof $value 4))")

(action_tile "KBS"  "(kb_switch)")
(action_tile "POPS" "(list_switch)")

(action_tile "mmps" "(setq mm_in_ps 1)")
(action_tile "inps" "(setq mm_in_ps 0)")

(action_tile "mmls" "(setq mm_in_ls 1)")
(action_tile "inls" "(setq mm_in_ls 0)")

(action_tile "mmsm" "(setq mm_in_sm 1)")
(action_tile "insm" "(setq mm_in_sm 0)")

(action_tile "title" "(setq title $value)")

(action_tile "ad_list" "(ad_list)")

; Sheet Size Popup

(action_tile "accept" "(done_dialog 4)")
(action_tile "cancel" "(done_dialog 0)")
(action_tile "help" "(do_help)")																				
(setq WHAT_NOW (start_dialog))
(unload_dialog I_CARD)
(if (= WHAT_NOW 4)
(progn
(set)      ;; set system variables
(pulldown) ;; process pull down for sheet size
(calc_ps)  ;; calculate paper size
(calc_ls)  ;; calculate sheet size
(calc_sm)  ;; calculate sheet margins
(outline)  ;; draw outline
(margin)   ;; draw margins
(calc_pri) ;; primary calculation for l-l or l-w
;;(alert_opt);; alert option selected l-l or l-w
(best_fit) ;; actual program
(reset)    ;; reset system variables
(rethink)  ;; for adjusting margins
); progn

(progn
(set)
(reset)
(princ)
)
); if what_now
); defun  labo

;*************;*************;*************;*************;*************;

(defun kb_switch()  ;;  KeyBoard ON
   (setq kb_list 1)
   (mode_tile "al_list" 1)
   (mode_tile "LS" 0)
   (mode_tile "WS" 0)
)

;;  End of the kb_switch function.

;;  Set up the list_switch function.

(defun list_switch()   ;; List ON
   (setq kb_list 0)
   (mode_tile "al_list" 0)
   (mode_tile "LS" 1)
   (mode_tile "WS" 1)
)
;;  End of the list_switch function.

(defun do_help ()

(setq msg1 "      Best Fit Label Layout")
(setq msg2 "\n\nCurrently No Help is Available")
;;(setq msg3 "\n\n - Tushar Suradkar")
(setq help (strcat msg1 msg2))
(alert help)
)
;; End of do_help

;*************;*************;*************;*************;*************;

(defun set ()

(setq CE (getvar "cmdecho"))
(setq BM (getvar "blipmode"))
(setq OSMODE (getvar "osmode"))
(setq LUNITS (getvar "lunits"))
(setq LUPREC (getvar "luprec"))
(setq PBOX (getvar "pickbox"))

(setvar "cmdecho" 0)
(setvar "blipmode" 0)
(setvar "osmode" 0)
(setvar "lunits" 2)
(setvar "luprec" 4)
(setvar "pickbox" 0)

) ;; defun set

;*************;*************;*************;*************;*************;

(defun pulldown()
(if (= kb_list 0)
(progn

(setq in_file (open (findfile "list.txt") "r"))
(repeat (+ al_index 1)
(setq in_value (read-line in_file))
)
(close in_file)

(if (= (strlen in_value) 27)
    (setq in_wid (substr in_value 18 3))
    (setq in_wid (substr in_value 16 3))
)
(setq ws_pull (distof in_wid))

(if (= (strlen in_value) 27)
    (setq in_len (substr in_value 24 3))
    (setq in_len (substr in_value 22 3))
)
(setq ls_pull (distof in_len))

) ;; progn
) ;; if
) ;; defun pulldown


;*************;*************;*************;*************;*************;

(defun calc_ps()  ;; paper size

(if (= kb_list 0)

    (setq ls ls_pull ws ws_pull)
)

(if (= kb_list 1)

    (if (= mm_in_ps 1)  ;; ie. mm is ON
        (setq ls (fix ls_ed) ws (fix ws_ed))
        (setq ls (fix (* ls_ed 25.4)) ws (fix (* ws_ed 25.4)))
    )

)

) ;; defun calc_ps

;*************;*************;*************;*************;*************;

(defun calc_ls() ;; label size

(if (= mm_in_ls 1)
    (setq ll ll_ed wl wl_ed)
    (setq ll (* ll_Ed 25.4) wl (* wl_ed 25.4))
)

) ;; defun calc_ls

;*************;*************;*************;*************;*************;

(defun calc_sm()  ;; sheet margins

(if (= mm_in_sm 1)

    (setq left left_ed right right_ed top top_ed bottom bottom_ed)

    (setq left (* left_ed 25.4) right  (* right_ed  25.4)
          top  (* top_ed  25.4) bottom (* bottom_ed 25.4)
    )
)

) ;; defun calc_sm

;*************;*************;*************;*************;*************;

(defun alert_val()
(setq val1 (strcat "length of sheet = " (rtos ls))
      val2 (strcat "\nwidth  of sheet = " (rtos ws))
      val3 (strcat "\nlength of label = " (rtos ll))
      val4 (strcat "\nwidth  of label = " (rtos wl))
      val5 (strcat "\nleft margin = " (rtos left))
      val6 (strcat "\nright margin = " (rtos right))
      val7 (strcat "\ntop margin = " (rtos top))
      val8 (strcat "\nbottom margin = " (rtos bottom) "\n")
      val9 title
)
(alert (strcat val1 val2 val3 val4 val5 val6 val7 val8 val9))
)

;*************;*************;*************;*************;*************;
; Draw Sheet Outline

(defun outline ()

(if (not LS) (setq LS 550))
(if (not WS) (setq WS 350))
(if (not LL) (setq LL 55))
(if (not WL) (setq WL 34))

(if (not LEFT) (setq LEFT 10))
(if (not RIGHT) (setq RIGHT 10))
(if (not TOP) (setq TOP 10))
(if (not BOTTOM) (setq BOTTOM 10))

(if (not title) (setq title "Officer's Choice"))

(if (not mm_in_ps) (setq mm_in_ps 1))
(if (not mm_in_ls) (setq mm_in_ls 1))
(if (not mm_in_sm) (setq mm_in_sm 1))
(if (not kb_list) (setq kb_list 1))

(if (not ls_ed) (setq ls_Ed 550))
(if (not ws_ed) (setq ws_ed 350))

(if (not ll_ed) (setq ll_ed 55))
(if (not wl_ed) (setq wl_ed 34))
(if (not left_ed) (setq left_ed 10))
(if (not right_ed) (setq right_ed 10))
(if (not top_ed) (setq top_ed 10))
(if (not bottom_ed) (setq bottom_ed 10))

(setq newx (* ls 1.2))
(setq newy (* ws 1.2))

(command "limits" "" (list newx newy))
(command "zoom" "all")
(command "zoom" "all")

(setq stx (/ newx 10))
(setq sty (/ newy 10))
(setq p1 (list stx sty))

(setq x1 (car p1))
(setq y1 (cadr p1))

(setq x2 (+ x1 LS))
(setq y2 y1)
(setq p2 (list x2 y2))

(setq x3 x2)
(setq y3 (+ y2 WS))
(setq p3 (list x3 y3))

(setq x4 x1)
(setq y4 y3)
(setq p4 (list x4 y4))

(setq COL (getvar "cecolor"))
(setvar "cecolor" "3")
(command ".pline" p1 p2 p3 p4 "close")
(setvar "cecolor" COL)

);; End Sheet Outline

;*************;*************;*************;*************;*************;

;; Draw Sheet Actual Size with Margins

(defun margin ()
(setq xa1 (+ x1 left))
(setq ya1 (+ y1 bottom))
(setq pa1 (list xa1 ya1))

(setq xa2 (- x2 right))
(setq ya2 (+ y1 bottom))
(setq pa2 (list xa2 ya2))

(setq xa3 (- x3 right))
(setq ya3 (- y3 top))
(setq pa3 (list xa3 ya3))

(setq xa4 (+ x4 left))
(setq ya4 (- y4 top))
(setq pa4 (list xa4 ya4))

(setq COL (getvar "cecolor"))
(setvar "cecolor" "6")
(command ".pline" pa1 pa2 pa3 pa4 "close")
(setvar "cecolor" COL)

(setq las (distance pa1 pa2))
(setq was (distance pa1 pa4))

);; End Sheet Actual Size with Margins

;*************;*************;*************;*************;*************;

(defun calc_pri()

;; l-l
(setq no_lab_l_ll (fix (/ las ll))) ; number of labels along length
(setq no_lab_w_ll (fix (/ was wl))) ; number of labels along width
(setq no_lab_ll   (* no_lab_l_ll no_lab_w_ll)) ;; total

;; l-w
(setq no_lab_l_lw (fix (/ las wl))) ; number of labels along length
(setq no_lab_w_lw (fix (/ was ll))) ; number of labels along width
(setq no_lab_lw   (* no_lab_l_lw no_lab_w_lw)) ;; total

) ;; defun calc_pri

;*************;*************;*************;*************;*************;

(defun alert_opt()
(if (> no_lab_ll no_lab_lw)
    (alert "Option l-l selected")
    (alert "Option l-w selected")
)

) ;; defun alert_opt

;*************;*************;*************;*************;*************;

(defun best_fit()

(if (>= no_lab_ll no_lab_lw)
    (do_ll)
    (do_lw)
)

) ;; defun best_fit

;*************;*************;*************;*************;*************;

(defun do_ll()
(setq declare "ll")
(setq ll (fix ll))
(setq wl (fix wl))
;;(command "minsert" "name of block" ins_pt   x_scl   y_scl   rotn
;;                                            n_rows
;;					      n_cols
;;  				              d_rows
;;					      d_cols
(command "minsert" (findFile "lablock.dwg") pa1 ll wl "0"
 					    (- no_lab_w_ll 1) ;; n_rows
 					    (- no_lab_l_ll 1) ;; n_cols
					    wl                ;; d_rows
					    ll                ;; d_cols
)
(setq klb (entlast))
(eb klb)
(setq tot_lab_ll (fix (* (- no_lab_w_ll 1)
 		         (- no_lab_l_ll 1)
                      )
  		 )
)
(setq d1$ (- was (* wl (- no_lab_w_ll 1))))
(setq dw$ (* wl (- no_lab_w_ll 1)))
(setq ptop1 (polar pa1 1.5708 dw$))
(if (>= d1$ ll) (progn
    (command "minsert" (findFile "lablock.dwg") ptop1  wl  ll "0"
						"1"              ;; n_rows
						(fix (/ las wl)) ;; n_cols
						                 ;; d_rows
						wl               ;; d_cols
    )
    (setq klb (entlast)) ;;********;;****
    (eb klb)
    (setq tot_lab_ll (fix (+ tot_lab_ll (fix (/ las wl)))))
    (setq top_notch 1)
                ) ;; progn
    (progn  ;; else
    (command "minsert" (findFile "lablock.dwg") ptop1  ll  wl "0"
						"1"  	          ;; n_rows
						(- no_lab_l_ll 1) ;; n_cols
								  ;; d_rows
						ll		  ;; d_cols
    )
    (setq klb (entlast)) ;;********;;****
    (eb klb)
    (setq tot_lab_ll (fix (+ tot_lab_ll (- no_lab_w_ll 1))))
    (setq top_notch 0)
    ) ;; else progn
) ;; if top side
(setq d2$ (- las (* ll (- no_lab_l_ll 1))))
(setq dl$ (* ll (- no_lab_l_ll 1)))
(setq pr1 (polar pa1 0 dl$))
    (if (= top_notch 0)
        (setq n_rows$ (fix (/ was ll)))
        (setq n_rows$ (fix (/ dw$ ll)))
    )
(if (>= d2$ (+ ll wl)) (progn
    (command "minsert" (findFile "lablock.dwg") pr1 ll wl "0"
						(if (= top_notch 0)
						(fix (+ (/ dw$ wl) 1))
						(fix (/ dw$ wl))
						)           	    ;; n_rows
						"1"		    ;; n_cols
		  				wl      	    ;; d_rows
   	 					                    ;; d_cols
    )
    (setq klb (entlast)) ;;********;;****
    (eb klb)
    (setq tot_lab_ll (+ tot_lab_ll (if (= top_notch 0)
				       (fix (+ (/ dw$ wl) 1))
				       (fix (/ dw$ wl))
	             		       )

                     )
    )
    (command "minsert" (findFile "lablock.dwg") (polar pr1 0 ll ) wl ll "0"
						n_rows$            ;; n_rows
						"1"		   ;; n_cols
						ll      	   ;; d_rows
   						                   ;; d_cols
    )
    (setq klb (entlast)) ;;********;;****
    (eb klb)
    (setq tot_lab_ll (+ tot_lab_ll n_rows$))
                       ) ;; progn
                       (progn  ;; else
(if (>= d2$ (* wl 2)) (progn
    (command "minsert" (findFile "lablock.dwg") pr1 wl ll "0"
						n_rows$            ;; n_rows
						"2"		   ;; n_cols
						ll      	   ;; d_rows
   						wl                 ;; d_cols
    )
    (setq klb (entlast))
    (eb klb)
    (setq tot_lab_ll (fix (+ tot_lab_ll (* 2  n_rows$)))) ;; (/ dw$ ll)
    (if (and
        (>= (fix (- was (* ll (fix (/ was ll ))) )) wl)
        (= top_notch 0)
        ) (progn
          (setq pr2$1 (polar pr1 1.5708 (fix (* ll (fix (/ was ll))))))
          (command "insert" (findFile "lablock.dwg") pr2$1 ll  wl "0")
          (setq tot_lab_ll (+ tot_lab_ll 1))
          );; progn
    )
    (if (and
        (>= (fix (- dw$ (* ll (fix (/ dw$ ll ))) )) wl)
        (= top_notch 1)
        ) (progn
          (setq pr2 (polar pr1 1.5708 (fix (* ll (fix (/ dw$ ll))))))
          (command "insert" (findFile "lablock.dwg") pr2 ll wl "0")
          (setq tot_lab_ll (+ tot_lab_ll 1))
          );; progn
    )

                      ) ;; progn
    (progn    ;; else
    (if (= top_notch 0)
        (setq n_rows$ (fix (/ was wl)))
        (setq n_rows$ (fix (/ dw$ wl)))
    )
    (command "minsert" (findFile "lablock.dwg") pr1 ll wl "0"
						n_rows$            ;; n_rows
						"1"		   ;; n_cols
						wl      	   ;; d_rows
								   ;; d_cols
    )
    (setq klb (entlast))
    (eb klb)
    (setq tot_lab_ll (fix (+ tot_lab_ll n_rows$)))
    ) ;; else progn
  ) ;; progn
 ) ;; if right side
)  ; if
(deco)
) ;; do_ll

;*************;*************;*************;*************;*************;

(defun do_lw()
(setq declare "lw")
(setq ll (fix ll))
(setq wl (fix wl))

;;(command "minsert" "name of block" ins_pt   x_scl   y_scl   rotn
;;                                            n_rows
;;					      n_cols
;;  				              d_rows
;;					      d_cols
(command "minsert" (findFile "lablock.dwg") pa1 wl ll "0"
 					    (- no_lab_w_lw 1) ;; n_rows
 					    (- no_lab_l_lw 1) ;; n_cols
					    ll                ;; d_rows
					    wl                ;; d_cols
)
(setq klb (entlast))
(eb klb)
(setq tot_lab_lw (fix (* (- no_lab_l_lw 1)
 		         (- no_lab_w_lw 1)
                      )
  		 )
)
;;^^^^^^########~~~~~~ right side start ~~~~~~~~~~~~~

(setq d2$ (- las (* wl (- no_lab_l_lw 1))))
(setq dl$ (- las d2$))
(setq pr1 (polar pa1 0 dl$))
(if (>= d2$ ll) (progn
    (setq out_right 1)
    (command "minsert" (findFile "lablock.dwg") pr1 ll wl "0"
					        (fix (/ was wl)) ;; n_rows
					        "1"		 ;; n_cols
					         wl     	 ;; d_rows
					        		 ;; d_cols
    )
    (setq tot_lab_lw (+ tot_lab_lw (fix (/ was wl))))
    (setq klb (entlast))
    (eb klb)
                ) ;; progn
    (progn ;; else
    (setq dw$ (* ll (- no_lab_w_lw 1)))
    (setq out_right 0)
    (command "minsert" (findFile "lablock.dwg") pr1 wl ll "0"
					       (fix (/ dw$ ll))  ;; n_rows
					       "1"		 ;; n_cols
					       ll	         ;; d_rows
					        		 ;; d_cols
    )
    (setq klb (entlast))
    (eb klb)
    (setq tot_lab_lw (+ tot_lab_lw (fix (/ dw$ ll))))
    ) ;; progn
) ;; if right side
;;^^^^^^########~~~~~~ right side end ~~~~~~~~~~~~~
;;^^^^^^########~~~~~~ top side start ~~~~~~~~~~~~~

(setq d1$ (- was (* ll (- no_lab_w_lw 1))))
(setq dw$ (* ll (- no_lab_w_lw 1)))
(setq ptop1 (polar pa1 1.5708 dw$))
(if (= out_right 1)
    (setq n_cols$2 (fix (/ dl$ ll)))
    (setq n_cols$2 (fix (/ las ll)))
)
(if (= out_right 1)
    (setq n_cols$1 (fix (/ dl$ wl)))
    (setq n_cols$1 (fix (/ las wl)))
)
(setq rose (fix (/ d1$ wl)))
(if (>= d1$ (* wl 2)) (progn
    (command "minsert" (findFile "lablock.dwg") ptop1 ll wl "0"
						rose              ;; n_rows
	 					n_cols$2         ;; n_cols
						wl               ;; d_rows
						ll               ;; d_cols
    )
    (setq klb (entlast)) ;;********;;****
    (eb klb)
    (setq tot_lab_lw (fix (+ tot_lab_lw (fix (* n_cols$2 2)))))
    (setq pfin (polar ptop1 0 dl$))
    (command "insert" (findFile "lablock.dwg") pfin wl ll "0")
    (setq tot_lab_lw (fix (+ tot_lab_lw 1)))
                ) ;; progn
    (progn  ;; else

(command "minsert" (findFile "lablock.dwg") ptop1 wl ll "0" "1" n_cols$1 wl)
    (setq klb (entlast)) ;;********;;****
    (eb klb)
    (setq tot_lab_lw (fix (+ tot_lab_lw n_cols$1)))
    ) ;; else progn
) ;; if top side
;;^^^^^^########~~~~~~ top side end ~~~~~~~~~~~~~
(deco)
) ;; defun do_lw

;*************;*************;*************;*************;*************;

(defun reset()

(setvar "cmdecho" CE)
(setvar "blipmode" BM)
(setvar "osmode" OSMODE)
(setvar "lunits" LUNITS)
(setvar "luprec" LUPREC)
(setvar "pickbox" PBOX)

); defun reset

;*************;*************;*************;*************;*************;
(defun eb (blk)
(setq                          ;;a blk ;; (entsel)
	e (entget blk)         ;;e (entget (car a))
	p (cdr (assoc 2 e))
	ip (cdr (assoc 10 e))
	x (cdr (assoc 43 e))
	y (cdr (assoc 42 e))
	r (cdr (assoc 71 e))
	c (cdr (assoc 70 e))
	dr (cdr (assoc 45 e))
	dc (cdr (assoc 44 e))
	ang1 (cdr (assoc 50 e))
)
(if (= r 0) (setq r 2))
(if (= c 0) (setq c 2))
(command "erase" ip "")
(command "insert" p ip x y (rtd ang1))
(setvar "snapang" ang1)
(command "array" ip "" "rectangular" (fix r) (fix c) dr dc)
(command "explode" e)
(setvar "snapang" 0)
)
(defun rtd(kkk)
(* kkk 57.2958)
)

;*************;*************;*************;*************;*************;

(defun rethink()
(setq rethink_card (load_dialog "rethink.dcl"))
(if (not (new_dialog "rethink" rethink_card)) (exit))

(action_tile "revert" "(done_dialog 4)")
(action_tile "done" "(done_dialog 0)")

(if (= declare "ll")
(set_tile "#lab" (setq tut (rtos tot_lab_ll 2 0)))
)

(if (= declare "lw")
(set_tile "#lab" (setq tut (rtos tot_lab_lw 2 0)))
)

(setq tot_area (* las was))
(setq tot_scrap (- tot_area (* ll wl (atoi tut))))
(setq scrap_1 (/ tot_scrap tot_area))
(setq scrap (* scrap_1 100))

(set_tile "scrap" (rtos scrap 2 2))

(setq decide (start_dialog))
(unload_dialog rethink_card)

(if (= decide 4)
    (c:lab2)
)
(princ)
) ;; defun rethink

;*************;*************;*************;*************;*************;

(defun deco()
(setq x_tit1 (car p1))
(setq y_tit1 (+ (cadr p1) ws (/ top 2)))
(setq p_tit1 (list x_tit1 y_tit1))
(if (= declare "ll")
    (setq labo (fix tot_lab_ll))
)
(if (= declare "lw")
    (setq labo (fix tot_lab_lw))
)
(setq ht$ top)
(setq txt$ (strcat title "    Paper : " (rtos ls 2 0) " x " (rtos ws 2 0)
            " [" (rtos (/ ls 25.4) 2 0) " x " (rtos (/ ws 25.4) 2 0) "]"
                "        " "No. of Labels = " (rtos labo 2 0)))
(setq p_tit2 (polar p_tit1 0 (* ls 0.75)))
(command "text" "justify" "align" p_tit1 p_tit2 txt$)
(setq decre (* ht$ 2) $ht$ (/ ht$ 1.25))
(setq tms1 (polar p_tit1 0      (+ ls right)))
(setq tms2 (polar tms1   4.7115 decre))
(setq tms3 (polar tms2   4.7115 decre))
(setq tms4 (polar tms3   4.7115 decre))
(setq tms5 (polar tms4   4.7115 decre))
(setq tms6 (polar tms5   4.7715 (* decre 2)))
(setq tms7 (polar tms6   4.7715 decre))
(setq tms8 (polar tms7   4.7715 decre))
(setq tms9 (polar p1     4.7115 (* top 1.5)))
(command "text" tms1 $ht$ "0" "Margins :")
(command "text" tms2 $ht$ "0" (strcat "Left : "   (rtos left 2 0)))
(command "text" tms3 $ht$ "0" (strcat "Right : "  (rtos right 2 0)))
(command "text" tms4 $ht$ "0" (strcat "Top : "    (rtos top 2 0)))
(command "text" tms5 $ht$ "0" (strcat "Bottom : " (rtos bottom 2 0)))
(command "text" tms6 $ht$ "0" "Label Size :")
(command "text" tms7 $ht$ "0" (strcat "Length : " (rtos ll 2 0)))
(command "text" tms8 $ht$ "0" (strcat "width : " (rtos wl 2 0)))
(command "text" tms9 $ht$ "0" "All Dimensions are in mm.")
) ;; defun deco_ll

;*************;*************;*************;*************;*************;

(defun ad_list()

(if (= mm_in_ps 1)
(progn
     (setq read_out1 (rtos ls_ed 2 0))
     (setq read_out2 (rtos ws_ed 2 0))

     (setq read_out3 (rtos (/ ls_ed 25.4) 2 2))
     (setq read_out4 (rtos (/ ws_ed 25.4) 2 2))

)
)

(if (= mm_in_ps 0)
(progn
     (setq read_out1 (rtos (* ls_ed 25.4) 2 0))
     (setq read_out2 (rtos (* ws_ed 25.4) 2 0))

     (setq read_out3 (rtos ls_ed 2 2))
     (setq read_out4 (rtos ws_ed 2 2))

)
)

;; 11.50 x 18.00   [292 x 457]

(setq read_out (strcat read_out4 " x " read_out3 "   ["  ;; small x big Inch
                       read_out2 " x " read_out1 "]"     ;; small x big mm
               )
)

(setq l_file (open "list.txt" "a"))
(write-line read_out l_file)
(close l_file)

(setq al_index 0 al_list nil al_list '())
(setq file (open "list.txt" "r"))
(setq line (read-line file))
(while line
     (setq al_list (append al_list (list line)))
     (setq line (read-line file))
) ;; while

(close file)

(start_list "al_list")
(mapcar 'add_list al_list)
(end_list)

(alert (strcat "Paper Size of" "\n\n"
               read_out4 " x " read_out3 "  Inches" "\n"
             "["  read_out2 " x " read_out1 "]  Millimeters" "\n\n"
               "Added to list at the End !"
       )
)
) ;; ad_list

;*************;*************;*************;*************;*************;

(princ "Label.lsp Loaded. Type <lab> to use") (terpri) (princ)
